import { world, system } from '@minecraft/server';
const ID = [
    "md:warden_sword"
    //can push custom item
]
world.afterEvents.itemUse.subscribe(({ source, itemStack }) => {
    if (ID.some(id => itemStack?.typeId === id)) {
        let closestEntity = null
        let minDistance = 15 // thats the max distance of the ray
        const cooldown = source.getItemCooldown("Wacool");
        if (cooldown == 0) {
            source.startItemCooldown("Wacool", 50);
            source.getEntitiesFromViewDirection().forEach(entityI => {
                if (entityI.distance < minDistance) {
                    //method to get the first mob in your croshair
                    minDistance = entityI.distance
                    closestEntity = entityI.entity
                }
                if (closestEntity !== null) {
                    const playerPos = source.getHeadLocation()
                    const entityPos = closestEntity.location
                    const direction = {
                        x: entityPos.x - playerPos.x,
                        y: entityPos.y - playerPos.y,
                        z: entityPos.z - playerPos.z
                    };
                    const magnitude = Math.sqrt(direction.x ** 2 + direction.y ** 2 + direction.z ** 2)
                    const step = {
                        x: direction.x / magnitude,
                        y: direction.y / magnitude,
                        z: direction.z / magnitude
                    };
                    for (let i = 0; i <= Math.floor(minDistance); i++) {
                        const particlePos = {
                            x: playerPos.x + step.x * i,
                            y: playerPos.y + step.y * i,
                            z: playerPos.z + step.z * i
                        };
                        //spawn particle, sound and apply Damage
                        const ehealth = closestEntity.getComponent(`health`).currentValue
                        if (ehealth == 0) {
                            source.dimension.playSound(`mob.warden.death`, closestEntity.location, { pitch: 1, volume: 1 })

                        }
                        source.dimension.spawnParticle("minecraft:sonic_explosion", particlePos)
                        source.playSound(`mob.warden.attack`, { pitch: 1, volume: 1 })
                        closestEntity.applyDamage(60 / minDistance)
                    }
                }
            })
        }
    }
})